Overview

SpreadJS supports the name concept from Excel, in which you can define a name for a cell range, function, constant, or table.

The demo is being dynamically compiled to support real-time code editing... For quicker access to features, switch to the "JavaScript" tab for a smoother experience! :)
Description
app.js
index.html
styles.css
Copy to CodeMine

Use the addCustomName method to add a name to a workbook or worksheet:

    sheet.addCustomName('customName1','=SUM(A1,C3)', 1, 1, 'comment', false);

Use the removeCustomName method to remove a specified name from a workbook or worksheet:

    sheet.removeCustomName('customName1');

Use the clearCustomNames method to remove all names from a workbook or worksheet:

    sheet.clearCustomNames();

The custom NameInfo class includes the name, expression, row, column, comment and isReadOnly properties, of a workbook or worksheet:

    var nameInfo = sheet.getCustomName('customName1');
    // to get custom name
    var name = nameInfo.getName()
    // to get custom comment
    var comment = nameInfo.getComment();
    // to get custom readonly status
    var isReadOnly = nameInfo.isReadOnly();
    // to set custom readonly status
    nameInfo.isReadOnly(true);
    // to get custom expression
    var expression = nameInfo.getExpression();
    // to get expression string
    var expStr = GC.Spread.Sheets.CalcEngine.expressionToFormula(sheet, expression, 0, 0);

SpreadJS supports updating the custom NameInfo. Includes:

  • Renaming custom names and updating all referenced formulas
  • Changing the formula of the custom name
  • Updating comments of the custom name
spread.addCustomName("aaa","$A$1", 0, 0);
spread.sheets[0].setFormula(1, 1, "=aaa+1");
spread.getCustomName("aaa").set("bbb", "$A$2", 0, 0, "the configure");
Use the addCustomName method to add a name to a workbook or worksheet: Use the removeCustomName method to remove a specified name from a workbook or worksheet: Use the clearCustomNames method to remove all names from a workbook or worksheet: The custom NameInfo class includes the name, expression, row, column, comment and isReadOnly properties, of a workbook or worksheet: SpreadJS supports updating the custom NameInfo. Includes: Renaming custom names and updating all referenced formulas Changing the formula of the custom name Updating comments of the custom name
window.onload = initFunction; function initFunction() { var spread = new GC.Spread.Sheets.Workbook(document.getElementById("ss"), {sheetCount: 1}); spread.suspendPaint(); var sheet = spread.getActiveSheet(); sheet.setColumnWidth(1, 100); sheet.setValue(2, 1, "Sample scope:"); sheet.setValue(2, 2, 1); sheet.setValue(2, 3, 2); sheet.setValue(3, 2, 3); sheet.setValue(3, 3, 4); // add custom name sheet.addCustomName("customName1", "=$B$3", 0, 0, "this is a customName!"); sheet.setFormula(5, 1, "=customName1"); sheet.addCustomName("customName2", "=$C$3:$D$4", 0, 0, "this is another customName!"); sheet.setFormula(5, 2, "=sum(customName2)"); printNames(sheet); document.getElementById('setNameInfo').onclick = function () { var sheet = spread.getActiveSheet(); var name = document.getElementById('setname').value; if (name === '') { alert("name should not be empty"); return; } var comment = document.getElementById('setComment').value; var isReadOnly = document.getElementById('setIsReadOnly').checked; var formula = GC.Spread.Sheets.CalcEngine.rangeToFormula(sheet.getSelections()[0], 0, 0, GC.Spread.Sheets.CalcEngine.RangeReferenceRelative.allAbsolute); sheet.addCustomName(name, formula, 0, 0, comment, isReadOnly); printNames(sheet); }; function printNames(sheet) { var namesInfo = sheet.getCustomNames(); var str = "name\t\treference\n"; namesInfo.forEach(function (nameInfo) { var name = nameInfo.getName(); var reference = GC.Spread.Sheets.CalcEngine.rangeToFormula(nameInfo.getExpression().getRange()); str += name + " " + reference + '\n'; }); document.getElementById('allNameInfo').value = str; } sheet.bind(GC.Spread.Sheets.Events.CellClick, function (sender, args) { var sheet = args.sheet; var selection = sheet.getSelections()[0]; document.getElementById('setname').value = ''; document.getElementById('setComment').value = ''; document.getElementById('setIsReadOnly').checked = false; document.getElementById('reference').value = GC.Spread.Sheets.CalcEngine.rangeToFormula(selection); var customNames = sheet.getCustomNames(); for (var i = 0; i < customNames.length; i++) { var customName = customNames[i]; var range = customName.getExpression().getRange(); if (range.row === selection.row && range.col === selection.col && range.rowCount === selection.rowCount && range.colCount === selection.colCount) { var name = customName.getName(); var comment = customName.getComment(); var isReadOnly = customName.isReadOnly(); document.getElementById('setname').value = name; document.getElementById('setComment').value = comment; document.getElementById('setIsReadOnly').checked = !!isReadOnly; break; } } }); spread.resumePaint(); }
<!doctype html> <html style="height:100%;font-size:14px;"> <head> <meta charset="utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0" /> <link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css"> <script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/dist/gc.spread.sheets.all.min.js" type="text/javascript"></script> <script src="$DEMOROOT$/spread/source/js/license.js" type="text/javascript"></script> <script src="app.js" type="text/javascript"></script> <link rel="stylesheet" type="text/css" href="styles.css"> </head> <body> <div class="sample-tutorial"> <div id="ss" class="sample-spreadsheets"></div> <div class="options-container"> <strong class="sp-demo-HeaderTitle">Settings:</strong> <p style="padding:2px 10px">Select a range to add custom name.</p> <div id="settingsDiv" style="margin-top: 10px"> <div class="option-row"> <label for="setName">Name:</label> <input type="text" id="setname" placeholder="Name should not be empty"/> </div> <div class="option-row"> <label for="setComment">Comment:</label> <input type="text" id="setComment"/> </div> <div class="option-row"> <label for="setIsReadOnly">IsReadOnly:</label> <input type="checkbox" id="setIsReadOnly" /> </div> <div class="option-row"> <label for="reference">Reference:</label> <input type="text" id="reference"/> </div> <div class="option-row"> <input type="button" id="setNameInfo" value="Add Custom Name" style="width:125px; margin-left: 10px"/> </div> <div class="option-row"> <label for="reference">All CustomNames:</label> <textarea rows="5" cols="30" id="allNameInfo"></textarea> </div> </div> </div> </div></body> </html>
.sample-tutorial { position: relative; height: 100%; overflow: hidden; } .sample-spreadsheets { width: calc(100% - 280px); height: 100%; overflow: hidden; float: left; } .options-container { float: right; width: 280px; padding: 12px; height: 100%; box-sizing: border-box; background: #fbfbfb; overflow: auto; } .option-row { font-size: 14px; padding: 5px; } input { display:block; width: 100%; margin: 8px 0; box-sizing: border-box; } input[type=checkbox] { display: inline-block; width: initial; margin: 0; vertical-align: middle; } label, input { padding: 4px 6px; } body { position: absolute; top: 0; bottom: 0; left: 0; right: 0; }

Use the addCustomName method to add a name to a workbook or worksheet:
Use the removeCustomName method to remove a specified name from a workbook or worksheet:
Use the clearCustomNames method to remove all names from a workbook or worksheet:
The custom NameInfo class includes the name, expression, row, column, comment and isReadOnly properties, of a workbook or worksheet:
SpreadJS supports updating the custom NameInfo. Includes:
Renaming custom names and updating all referenced formulas
Changing the formula of the custom name
Updating comments of the custom name
import { Component, NgModule, enableProdMode } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { SpreadSheetsModule } from '@mescius/spread-sheets-angular';
import GC from '@mescius/spread-sheets';
import './styles.css';
function setValueById(id: string, value: string) {
(document.getElementById(id) as HTMLInputElement).value = value;
}
function getValueById(id: string) {
return (document.getElementById(id) as HTMLInputElement).value;
}
function setCheckedById(id: string, value: boolean) {
(document.getElementById(id) as HTMLInputElement).checked = value;
}
function getCheckedById(id: string) {
return (document.getElementById(id) as HTMLInputElement).checked;
}
@Component({
selector: 'app-component',
templateUrl: 'src/app.component.html'
})
export class AppComponent {
spread: GC.Spread.Sheets.Workbook;
hostStyle = {
width: 'calc(100% - 280px)',
height: '100%',
overflow: 'hidden',
float: 'left'
};
constructor() {
}
initSpread($event: any) {
this.spread = $event.spread;
let spread = this.spread;
spread.suspendPaint();
let sheet = spread.sheets[0];
sheet.setColumnWidth(1, 100);
sheet.setValue(2, 1, "Sample scope:");
sheet.setValue(2, 2, 1);
sheet.setValue(2, 3, 2);
sheet.setValue(3, 2, 3);
sheet.setValue(3, 3, 4);
// add custom name
sheet.addCustomName("customName1", "=$B$3", 0, 0, "this is a customName!");
sheet.setFormula(5, 1, "=customName1");
sheet.addCustomName("customName2", "=$C$3:$D$4", 0, 0, "this is another customName!");
sheet.setFormula(5, 2, "=sum(customName2)");
this.printNames(sheet);
sheet.bind(GC.Spread.Sheets.Events.CellClick, this.onCellClick);
spread.resumePaint();
}
printNames(sheet: GC.Spread.Sheets.Worksheet) {
let namesInfo = sheet.getCustomNames();
let str = "name\t\treference\n";
namesInfo.forEach(function (nameInfo) {
let name = nameInfo.getName();
let reference = GC.Spread.Sheets.CalcEngine.rangeToFormula(nameInfo.getExpression().getRange());
str += name + " " + reference + '\n';
});
setValueById('allNameInfo', str);
}
onAddCustomName($event: any) {
let sheet = this.spread.sheets[0];
let name = getValueById('setname');
if (name === '') {
alert("name should not be empty");
return;
}
let comment = getValueById('setComment');
let isReadOnly = getCheckedById('setIsReadOnly');
let formula = GC.Spread.Sheets.CalcEngine.rangeToFormula(sheet.getSelections()[0], 0, 0, GC.Spread.Sheets.CalcEngine.RangeReferenceRelative.allAbsolute);
sheet.addCustomName(name, formula, 0, 0, comment, isReadOnly);
this.printNames(sheet);
}
onCellClick(sender: any, args: any) {
let sheet = args.sheet;
let selection = sheet.getSelections()[0];
setValueById('setname', '');
setValueById('setComment', '');
setCheckedById('setIsReadOnly', false);
setValueById('reference', GC.Spread.Sheets.CalcEngine.rangeToFormula(selection));
let customNames = sheet.getCustomNames();
for (let i = 0; i < customNames.length; i++) {
let customName = customNames[i];
let range = customName.getExpression().getRange();
if (range.row === selection.row && range.col === selection.col
&& range.rowCount === selection.rowCount && range.colCount === selection.colCount) {
let name = customName.getName();
let comment = customName.getComment();
let isReadOnly = customName.isReadOnly();
setValueById('setname', name);
setValueById('setComment', comment);
setCheckedById('setIsReadOnly', !!isReadOnly);
break;
}
}
}
}
@NgModule({
imports: [BrowserModule, SpreadSheetsModule],
declarations: [AppComponent],
exports: [AppComponent],
bootstrap: [AppComponent]
})
export class AppModule {}
enableProdMode();
// Bootstrap application with hash style navigation and global services.
platformBrowserDynamic().bootstrapModule(AppModule);
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/angular/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- Polyfills -->
<script src="$DEMOROOT$/en/angular/node_modules/core-js/client/shim.min.js"></script>
<script src="$DEMOROOT$/en/angular/node_modules/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="$DEMOROOT$/en/angular/node_modules/systemjs/dist/system.js"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.import('@angular/compiler');
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('$DEMOROOT$/en/lib/angular/license.ts');
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<div class="sample-tutorial">
<gc-spread-sheets [hostStyle]="hostStyle" (workbookInitialized)="initSpread($event)">
<gc-worksheet>
</gc-worksheet>
</gc-spread-sheets>
<div class="options-container">
<strong class="sp-demo-HeaderTitle">Settings:</strong>
<p style="padding:2px 10px">Select a range to add custom name.</p>
<div id="settingsDiv" style="margin-top: 10px">
<div class="option-row">
<label for="setName">Name:</label>
<input type="text" id="setname" placeholder="Name should not be empty" />
</div>
<div class="option-row">
<label for="setComment">Comment:</label>
<input type="text" id="setComment" />
</div>
<div class="option-row">
<label for="setIsReadOnly">IsReadOnly:</label>
<input type="checkbox" id="setIsReadOnly" />
</div>
<div class="option-row">
<label for="reference">Reference:</label>
<input type="text" id="reference" />
</div>
<div class="option-row">
<input type="button" id="setNameInfo" value="Add Custom Name" style="width:125px; margin-left: 10px" (click)="onAddCustomName($event)" />
</div>
<div class="option-row">
<label for="reference">All CustomNames:</label>
<textarea rows="5" cols="30" id="allNameInfo"></textarea>
</div>
</div>
</div>
</div>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding: 5px;
}
input {
display:block;
width: 100%;
margin: 8px 0;
box-sizing: border-box;
}
input[type=checkbox] {
display: inline-block;
width: initial;
margin: 0;
vertical-align: middle;
}
label, input {
padding: 4px 6px;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
(function (global) {
System.config({
transpiler: 'ts',
typescriptOptions: {
tsconfig: true
},
meta: {
'typescript': {
"exports": "ts"
},
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'core-js': 'npm:core-js/client/shim.min.js',
'zone': 'npm:zone.js/fesm2015/zone.min.js',
'rxjs': 'npm:rxjs/dist/bundles/rxjs.umd.min.js',
'@angular/core': 'npm:@angular/core/fesm2022',
'@angular/common': 'npm:@angular/common/fesm2022/common.mjs',
'@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs',
'@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs',
'@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs',
'@angular/router': 'npm:@angular/router/fesm2022/router.mjs',
'@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs',
'jszip': 'npm:jszip/dist/jszip.min.js',
'typescript': 'npm:typescript/lib/typescript.js',
'ts': './plugin.js',
'tslib':'npm:tslib/tslib.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js',
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-angular': 'npm:@mescius/spread-sheets-angular/fesm2020/mescius-spread-sheets-angular.mjs',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'ts'
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
"node_modules/@angular": {
defaultExtension: 'mjs'
},
"@mescius/spread-sheets-angular": {
defaultExtension: 'mjs'
},
'@angular/core': {
defaultExtension: 'mjs',
main: 'core.mjs'
}
}
});
})(this);

Use the addCustomName method to add a name to a workbook or worksheet:
Use the removeCustomName method to remove a specified name from a workbook or worksheet:
Use the clearCustomNames method to remove all names from a workbook or worksheet:
The custom NameInfo class includes the name, expression, row, column, comment and isReadOnly properties, of a workbook or worksheet:
SpreadJS supports updating the custom NameInfo. Includes:
Renaming custom names and updating all referenced formulas
Changing the formula of the custom name
Updating comments of the custom name
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import './styles.css';
import { AppFunc } from './app-func';
import { App } from './app-class';
// 1. Functional Component sample
ReactDOM.render(<AppFunc />, document.getElementById('app'));
// 2. Class Component sample
// ReactDOM.render(<App />, document.getElementById('app'));
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import { SpreadSheets, Worksheet } from '@mescius/spread-sheets-react';
import './styles.css';
const useState = React.useState;
export function AppFunc() {
const [spread,setSpread] = useState(null);
const initSpread = (spread) => {
setSpread(spread);
var sheet = spread.sheets[0];
spread.suspendPaint();
sheet.setColumnWidth(1, 100);
sheet.setValue(2, 1, "Sample scope:");
sheet.setValue(2, 2, 1);
sheet.setValue(2, 3, 2);
sheet.setValue(3, 2, 3);
sheet.setValue(3, 3, 4);
// add custom name
sheet.addCustomName("customName1", "=$B$3", 0, 0, "this is a customName!");
sheet.setFormula(5, 1, "=customName1");
sheet.addCustomName("customName2", "=$C$3:$D$4", 0, 0, "this is another customName!");
sheet.setFormula(5, 2, "=sum(customName2)");
printNames(sheet);
sheet.bind(GC.Spread.Sheets.Events.CellClick, onCellClick);
spread.resumePaint();
}
const onAddCustomName = (e) => {
var sheet = spread.sheets[0];
var name = document.getElementById('setname').value;
if (name === '') {
alert("name should not be empty");
return;
}
var comment = document.getElementById('setComment').value;
var isReadOnly = document.getElementById('setIsReadOnly').checked;
var formula = GC.Spread.Sheets.CalcEngine.rangeToFormula(sheet.getSelections()[0], 0, 0, GC.Spread.Sheets.CalcEngine.RangeReferenceRelative.allAbsolute);
sheet.addCustomName(name, formula, 0, 0, comment, isReadOnly);
printNames(sheet);
}
const printNames = (sheet) => {
var namesInfo = sheet.getCustomNames();
var str = "name\t\treference\n";
namesInfo.forEach(function (nameInfo) {
var name = nameInfo.getName();
var reference = GC.Spread.Sheets.CalcEngine.rangeToFormula(nameInfo.getExpression().getRange());
str += name + " " + reference + '\n';
});
document.getElementById('allNameInfo').value = str;
}
const onCellClick = (sender, args) => {
var sheet = args.sheet;
var selection = sheet.getSelections()[0];
document.getElementById('setname').value = '';
document.getElementById('setComment').value = '';
document.getElementById('setIsReadOnly').checked = false;
document.getElementById('reference').value = GC.Spread.Sheets.CalcEngine.rangeToFormula(selection);
var customNames = sheet.getCustomNames();
for (var i = 0; i < customNames.length; i++) {
var customName = customNames[i];
var range = customName.getExpression().getRange();
if (range.row === selection.row && range.col === selection.col
&& range.rowCount === selection.rowCount && range.colCount === selection.colCount) {
var name = customName.getName();
var comment = customName.getComment();
var isReadOnly = customName.isReadOnly();
document.getElementById('setname').value = name;
document.getElementById('setComment').value = comment;
document.getElementById('setIsReadOnly').checked = !!isReadOnly;
break;
}
}
}
return <div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => initSpread(spread)}>
<Worksheet>
</Worksheet>
</SpreadSheets>
</div>
<Panel onAddCustomName={(e) => onAddCustomName(e)} />
</div>;
}
function Panel(props) {
return (
<div class="options-container">
<strong class="sp-demo-HeaderTitle">Settings:</strong>
<p style={{ padding: "2px 10px" }}>Select a range to add custom name.</p>
<div id="settingsDiv" style={{ marginTop: "10px" }}>
<div class="option-row">
<label htmlFor="setName">Name:</label>
<input type="text" id="setname" placeholder="Name should not be empty" />
</div>
<div class="option-row">
<label htmlFor="setComment">Comment:</label>
<input type="text" id="setComment" />
</div>
<div class="option-row">
<label for="setIsReadOnly">IsReadOnly:</label>
<input type="checkbox" id="setIsReadOnly" />
</div>
<div class="option-row">
<label htmlFor="reference">Reference:</label>
<input type="text" id="reference" />
</div>
<div class="option-row">
<input type="button" id="setNameInfo" value="Add Custom Name" style={{ width: "125px", marginLeft: "10px" }} onClick={(e) => props.onAddCustomName(e)} />
</div>
<div class="option-row">
<label htmlFor="reference">All CustomNames:</label>
<textarea rows={5} cols={30} id="allNameInfo"></textarea>
</div>
</div>
</div>
);
}
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import { SpreadSheets, Worksheet } from '@mescius/spread-sheets-react';
import './styles.css';
const Component = React.Component;
export class App extends Component {
constructor(props) {
super(props);
this.spread = null;
}
render() {
return <div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread=>this.initSpread(spread)}>
<Worksheet>
</Worksheet>
</SpreadSheets>
</div>
<Panel onAddCustomName={(e)=>{this.onAddCustomName(e)}} />
</div>;
}
initSpread(spread) {
this.spread = spread;
var sheet = spread.sheets[0];
spread.suspendPaint();
sheet.setColumnWidth(1, 100);
sheet.setValue(2, 1, "Sample scope:");
sheet.setValue(2, 2, 1);
sheet.setValue(2, 3, 2);
sheet.setValue(3, 2, 3);
sheet.setValue(3, 3, 4);
// add custom name
sheet.addCustomName("customName1", "=$B$3", 0, 0, "this is a customName!");
sheet.setFormula(5, 1, "=customName1");
sheet.addCustomName("customName2", "=$C$3:$D$4", 0, 0, "this is another customName!");
sheet.setFormula(5, 2, "=sum(customName2)");
this.printNames(sheet);
sheet.bind(GC.Spread.Sheets.Events.CellClick, this.onCellClick);
spread.resumePaint();
}
onAddCustomName(e) {
var sheet = this.spread.sheets[0];
var name = document.getElementById('setname').value;
if (name === '') {
alert("name should not be empty");
return;
}
var comment = document.getElementById('setComment').value;
var isReadOnly = document.getElementById('setIsReadOnly').checked;
var formula = GC.Spread.Sheets.CalcEngine.rangeToFormula(sheet.getSelections()[0], 0, 0, GC.Spread.Sheets.CalcEngine.RangeReferenceRelative.allAbsolute);
sheet.addCustomName(name, formula, 0, 0, comment, isReadOnly);
this.printNames(sheet);
}
printNames(sheet) {
var namesInfo = sheet.getCustomNames();
var str = "name\t\treference\n";
namesInfo.forEach(function (nameInfo) {
var name = nameInfo.getName();
var reference = GC.Spread.Sheets.CalcEngine.rangeToFormula(nameInfo.getExpression().getRange());
str += name + " " + reference + '\n';
});
document.getElementById('allNameInfo').value = str;
}
onCellClick(sender, args) {
var sheet = args.sheet;
var selection = sheet.getSelections()[0];
document.getElementById('setname').value = '';
document.getElementById('setComment').value = '';
document.getElementById('setIsReadOnly').checked = false;
document.getElementById('reference').value = GC.Spread.Sheets.CalcEngine.rangeToFormula(selection);
var customNames = sheet.getCustomNames();
for (var i = 0; i < customNames.length; i++) {
var customName = customNames[i];
var range = customName.getExpression().getRange();
if (range.row === selection.row && range.col === selection.col
&& range.rowCount === selection.rowCount && range.colCount === selection.colCount) {
var name = customName.getName();
var comment = customName.getComment();
var isReadOnly = customName.isReadOnly();
document.getElementById('setname').value = name;
document.getElementById('setComment').value = comment;
document.getElementById('setIsReadOnly').checked = !!isReadOnly;
break;
}
}
}
}
class Panel extends Component{
constructor(props){
super(props);
}
render(){
return(
<div class="options-container">
<strong class="sp-demo-HeaderTitle">Settings:</strong>
<p style={{padding: "2px 10px"}}>Select a range to add custom name.</p>
<div id="settingsDiv" style={{marginTop: "10px"}}>
<div class="option-row">
<label htmlFor="setName">Name:</label>
<input type="text" id="setname" placeholder="Name should not be empty"/>
</div>
<div class="option-row">
<label htmlFor="setComment">Comment:</label>
<input type="text" id="setComment"/>
</div>
<div class="option-row">
<label for="setIsReadOnly">IsReadOnly:</label>
<input type="checkbox" id="setIsReadOnly" />
</div>
<div class="option-row">
<label htmlFor="reference">Reference:</label>
<input type="text" id="reference"/>
</div>
<div class="option-row">
<input type="button" id="setNameInfo" value="Add Custom Name" style={{ width: "125px", marginLeft: "10px"}} onClick={(e)=>{this.props.onAddCustomName(e)}}/>
</div>
<div class="option-row">
<label htmlFor="reference">All CustomNames:</label>
<textarea rows={5} cols={30} id="allNameInfo"></textarea>
</div>
</div>
</div>
)
}
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/react/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- SystemJS -->
<script src="$DEMOROOT$/en/react/node_modules/systemjs/dist/system.src.js"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('$DEMOROOT$/en/lib/react/license.js').then(function () {
System.import('./src/app');
});
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding: 5px;
}
input {
display:block;
width: 100%;
margin: 8px 0;
box-sizing: border-box;
}
input[type=checkbox] {
display: inline-block;
width: initial;
margin: 0;
vertical-align: middle;
}
label, input {
padding: 4px 6px;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
#app {
height: 100%;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-react': 'npm:@mescius/spread-sheets-react/index.js',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js',
'react': 'npm:react/umd/react.production.min.js',
'react-dom': 'npm:react-dom/umd/react-dom.production.min.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);

Use the addCustomName method to add a name to a workbook or worksheet:
Use the removeCustomName method to remove a specified name from a workbook or worksheet:
Use the clearCustomNames method to remove all names from a workbook or worksheet:
The custom NameInfo class includes the name, expression, row, column, comment and isReadOnly properties, of a workbook or worksheet:
SpreadJS supports updating the custom NameInfo. Includes:
Renaming custom names and updating all referenced formulas
Changing the formula of the custom name
Updating comments of the custom name
<template>
<div class="sample-tutorial">
<gc-spread-sheets class="sample-spreadsheets" @workbookInitialized="initSpread">
<gc-worksheet>
</gc-worksheet>
</gc-spread-sheets>
<div class="options-container">
<strong class="sp-demo-HeaderTitle">Settings:</strong>
<p style="padding:2px 10px">Select a range to add custom name.</p>
<div id="settingsDiv" style="margin-top: 10px">
<div class="option-row">
<label for="setName">Name:</label>
<input type="text" id="setname" placeholder="Name should not be empty"/>
</div>
<div class="option-row">
<label for="setComment">Comment:</label>
<input type="text" id="setComment"/>
</div>
<div class="option-row">
<label for="setIsReadOnly">IsReadOnly:</label>
<input type="checkbox" id="setIsReadOnly" />
</div>
<div class="option-row">
<label for="reference">Reference:</label>
<input type="text" id="reference"/>
</div>
<div class="option-row">
<input type="button" id="setNameInfo" value="Add Custom Name" style="width:125px; margin-left: 10px" @click="onAddCustomName($event)" />
</div>
<div class="option-row">
<label for="reference">All CustomNames:</label>
<textarea rows="5" cols="30" id="allNameInfo"></textarea>
</div>
</div>
</div>
</div>
</template>
<script setup>
import GC from "@mescius/spread-sheets";
import { ref } from 'vue';
const spreadRef = ref(null);
function initSpread (spread) {
spreadRef.value = spread;
var sheet = spread.getSheet(0);
spread.suspendPaint();
sheet.setColumnWidth(1, 100);
sheet.setValue(2, 1, "Sample scope:");
sheet.setValue(2, 2, 1);
sheet.setValue(2, 3, 2);
sheet.setValue(3, 2, 3);
sheet.setValue(3, 3, 4);
// add custom name
sheet.addCustomName("customName1", "=$B$3", 0, 0, "this is a customName!");
sheet.setFormula(5, 1, "=customName1");
sheet.addCustomName("customName2", "=$C$3:$D$4", 0, 0, "this is another customName!");
sheet.setFormula(5, 2, "=sum(customName2)");
printNames(sheet);
sheet.bind(GC.Spread.Sheets.Events.CellClick, onCellClick);
spread.resumePaint();
}
function onAddCustomName(e) {
var sheet = spreadRef.value.sheets[0];
var name = document.getElementById('setname').value;
if (name === '') {
alert("name should not be empty");
return;
}
var comment = document.getElementById('setComment').value;
var isReadOnly = document.getElementById('setIsReadOnly').checked;
var formula = GC.Spread.Sheets.CalcEngine.rangeToFormula(sheet.getSelections()[0], 0, 0, GC.Spread.Sheets.CalcEngine.RangeReferenceRelative.allAbsolute);
sheet.addCustomName(name, formula, 0, 0, comment, isReadOnly);
printNames(sheet);
}
function printNames(sheet) {
var namesInfo = sheet.getCustomNames();
var str = "name\t\treference\n";
namesInfo.forEach(function (nameInfo) {
var name = nameInfo.getName();
var reference = GC.Spread.Sheets.CalcEngine.rangeToFormula(nameInfo.getExpression().getRange());
str += name + " " + reference + '\n';
});
document.getElementById('allNameInfo').value = str;
}
function onCellClick(sender, args) {
var sheet = args.sheet;
var selection = sheet.getSelections()[0];
document.getElementById('setname').value = '';
document.getElementById('setComment').value = '';
document.getElementById('setIsReadOnly').checked = false;
document.getElementById('reference').value = GC.Spread.Sheets.CalcEngine.rangeToFormula(selection);
var customNames = sheet.getCustomNames();
for (var i = 0; i < customNames.length; i++) {
var customName = customNames[i];
var range = customName.getExpression().getRange();
if (range.row === selection.row && range.col === selection.col
&& range.rowCount === selection.rowCount && range.colCount === selection.colCount) {
var name = customName.getName();
var comment = customName.getComment();
var isReadOnly = customName.isReadOnly();
document.getElementById('setname').value = name;
document.getElementById('setComment').value = comment;
document.getElementById('setIsReadOnly').checked = !!isReadOnly;
break;
}
}
}
</script>
<style scoped>
#app {
height: 100%;
}
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding: 5px;
}
input {
display:block;
width: 100%;
margin: 8px 0;
box-sizing: border-box;
}
input[type=checkbox] {
display: inline-block;
width: initial;
margin: 0;
vertical-align: middle;
}
label, input {
padding: 4px 6px;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
</style>
<!DOCTYPE html>
<html lang="en" style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<title>SpreadJS VUE</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css"
href="$DEMOROOT$/en/vue3/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/en/vue3/node_modules/systemjs/dist/system.src.js"></script>
<script src="./systemjs.config.js"></script>
<script src="./compiler.js" type="module"></script>
<script>
var System = SystemJS;
System.import("./src/app.js");
System.import('$DEMOROOT$/en/lib/vue3/license.js');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
(function (global) {
SystemJS.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
packageConfigPaths: [
'./node_modules/*/package.json',
"./node_modules/@mescius/*/package.json",
"./node_modules/@babel/*/package.json",
"./node_modules/@vue/*/package.json"
],
map: {
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-vue': 'npm:@mescius/spread-sheets-vue/index.js',
'vue': "npm:vue/dist/vue.esm-browser.js",
'tiny-emitter': 'npm:tiny-emitter/index.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
"systemjs-babel-build": "npm:systemjs-plugin-babel/systemjs-babel-browser.js",
},
meta: {
'*.css': { loader: 'systemjs-plugin-css' },
'*.vue': { loader: "../plugin-vue/index.js" }
}
});
})(this);